## secnet 0.6.8

=== base91-c/Makefile ===
CFLAGS = -Wall -W -O2
LDFLAGS = -s

CC = gcc
INSTALL = install
INSTALL_DATA = $(INSTALL) -m 444
INSTALL_PROGRAM = $(INSTALL) -m 555

prefix = /usr/local
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
mandir = $(prefix)/share/man
man1dir = $(mandir)/man1
manext = .1

BIN = base91 lentest

.PHONY: all install check clean

all: $(BIN)

%.o: %.c
	$(CC) $(CFLAGS) -c $<

base91: cli.o base91.o
	$(CC) $(LDFLAGS) -o $@ $^

lentest: lentest.o base91.o

install: all
	mkdir -p $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) base91 $(DESTDIR)$(bindir)/base91
	ln -sf base91 $(DESTDIR)$(bindir)/b91dec
	ln -sf base91 $(DESTDIR)$(bindir)/b91enc
	mkdir -p $(DESTDIR)$(man1dir)
	$(INSTALL_DATA) base91.1 $(DESTDIR)$(man1dir)/base91$(manext)
	ln -sf base91$(manext) $(DESTDIR)$(man1dir)/b91dec$(manext)
	ln -sf base91$(manext) $(DESTDIR)$(man1dir)/b91enc$(manext)

check: all
	cd test && $(MAKE)

clean:
	-rm -f *.o $(BIN) core
	cd test && $(MAKE) clean

=== base91-c/test/Makefile ===
SHELL = /bin/sh

.PHONY: all clean

all:
	ln -sf ../base91 b91enc
	ln -sf ../base91 b91dec
	ln -sf ../lentest .
	$(SHELL) test.sh

clean:
	-rm -f b91??c *.b91 *.dat core

## secnet 0.5.0

=== debian/changelog ===
secnet (0.5.0) unstable; urgency=medium

  make-secnet-sites SECURITY FIX:
  * Do not blindly trust inputs; instead, check the syntax for sanity.
    Previous releases can be induced to run arbitrary code as the user
    invoking secnet (which might be root), if a secnet sites.conf is used
    that was generated from an untrustworthy sites file.
  * The userv invocation mode of make-secnet-sites seems to have been safe
    in itself, but it previously allowed hazardous data to be propagated
    into the master sites file.  This is now prevented too.

  make-secnet-sites overhaul work:
  * make-secnet-sites is now in the common subset of Python2 and Python3.
    The #! is python3 now, but it works with Python2.7 too.
    It will probably *not* work with old versions of Python2.
  * We no longer depend on the obsolete `ipaddr' library.  We use
    `ipaddress' now.  And this is onlo a Recommends in the .deb.
  * Ad-hoc argument parser been replaced with `argparse'.
    There should be no change to existing working invocations.
  * Bad address syntax error does not wrongly mention IPv6 scopes.
  * Minor refactoring to support forthcoming work.  [Mark Wooding]

  other bugfixes, improvements and changes to secnet itself:
  * Better logging of why we are sending NAK messages.
  * Correctly use the verified copy of the peer remote capabilities
    from MSG3.  (Bug is not a vulnerability.)    [Mark Wooding]
  * Significant internal rearrangements and refactorings, to support
    forthcoming key management work.  [Mark Wooding and Ian Jackson]

  build system etc.:
  * Completely overhaul release checklist; drop dist target.
  * Remove dependency on `libfl.a'.  [Mark Wooding]
  * polypath.c: Fix missing include of <limits.h>.  [Mark Wooding]
  * Add a Wireshark dissector `secnet-wireshark.lua'.  It is not
    installed anywhere right now.  [Mark Wooding]

  documentation:
  * Improve documentation of capability negotiation in NOTES, secnet(8)
    and magic.h.  [Mark Wooding]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 24 Oct 2019 19:11:54 +0100

secnet (0.4.5) unstable; urgency=medium

  * INSTALL: Mention that rsa key generation might need ssh-keygen1.
  * mobile: Fix negotiation bug with mixed old/new secnets and
    simultaneous key setup attempts by each end.  [Mark Wooding]
  * Makefile.in: Support installation from a `VPATH' build.  [Mark Wooding]
  * Portability fixes for clang.  [Mark Wooding]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 21 Sep 2019 12:04:31 +0100

secnet (0.4.4) unstable; urgency=medium

  Security fix:
  * make-secnet-sites: Don't allow setting new VPN-level properties
    when restricted.  This could allow denial of service by
    users with delegated authorisation.  [Mark Wooding]

  Bugfixes for poor network environments:
  * polypath: cope properly with asymmetric routing, by correcting
    the handling of late duplicated packets etc.   Protocol is now
    incompatible with secnet prior to 0.3.0 when either end is mobile.
  * Randomise key setup retry time.

  Other bugfixes:
  * rsa and cbcmac: Fix configuration error messages.  [Mark Wooding]
  * Handle IPv4 addresses properly (ie, not foolishly byte-swapped),
    when IPv6 is not available.  [Mark Wooding]
  * Better logging (and less foolish debug), especially about whether
    key is set up, and about crossed key setup attempts.
  * Internal refactoring and fixes.  [Ian Jackson and Mark Wooding]

  Build system and portability:
  * configure: rerun autogen.sh with autoconf 2.69-10
  * Avoid memset(0,0,0) wrt st->sharedsecret.  (Fixes compiler warning;
    in theory might cause miscompilation.)  [Mark Wooding]

  Documentation:
  * README.make-secnet-sites: new documentation file.  [Mark Wooding]
  * NOTES: Describe current allocation of capability bits.  [Mark Wooding]
  * NOTES: tiny fix tot protocol description.
  * secnet(8): Delete wrong information about dh groups.  [Mark Wooding]

  Administrivia:
  * Fix erroneous GPL3+ licence notices "version d or later" (!)
  * .dir-locals.el: Settings for Python code.  [Mark Wooding]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 08 Sep 2019 22:53:14 +0100

secnet (0.4.3) unstable; urgency=low

  Security improvement:
  * Use `mpz_powm_sec' for modexps.

  Enhancements:
  * Implement comm-info and dedicated-interface-addr feature, for
    benefit of hippotat.
  * Implement `keepalive' site option, to try to keep link always up.

  Build etc. fixes:
  * #include <limits.h> (fixes the build on jessie).
  * Tolerate building from a git checkout, but with git not installed.
    (This can happen in chroots.)
  * Turn off -Wsign-compare for bison output.
  * Makefile.in: Fix `check-ipaddrset' rule to get reference from
    $(srcdir).  (Makes out-of-tree builds work properly.)
  * Release checklist fixes.
  * Burn version numbers 0.4.1 and 0.4.2 due to errors in release prep.

  Bugfixes:
  * When printing messages about dropping IPv6, do not print anything
    about ihl.  (Check the IP version field first!)
  * When turning on debug, turn on verbose too.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 25 Nov 2017 13:36:41 +0000

secnet (0.4.0) unstable; urgency=low

  Debugging improvements:
  * Packet-level debugging from site notes errors from transmit.
  * Report when transport peers updated as a result of transmit.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 28 Feb 2015 15:03:00 +0000

secnet (0.4.0~beta2) unstable; urgency=low

  Polypath bugfixes:
  * Ignore IPv6 Unique Local unicast addresses.
  * Skip "tentative" IPv6 local addresses.
  * Improve logging and debug output.

  Portability fix:
  * Build where size_t is not compatible with int.

  Build system and packaging fixes:
  * Makefile: support DESTDIR.
  * debian/rules: set DESTDIR (not prefix).
  * debian/rules: Support dpkg-buildflags.
  * Install ipaddrset.py and secnet.8 with correct permissions.


=== debian/control ===
Source: secnet
Section: net
Priority: extra
Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
Uploaders: Stephen Early <steve@greenend.org.uk>,
           Richard Kettlewell <rjk@terraraq.org.uk>
Build-Depends: debhelper (>= 5), libgmp3-dev, libadns1-dev, bison, flex,
               libbsd-dev, python3, tclx, tcl, libtcl-chiark-1
Standards-Version: 3.0.1

Package: secnet
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: python3
Description: VPN software for distributed networks
 secnet allows multiple private networks, each 'hidden' behind a single
 globally-routable IP address, to be bridged together.

## secnet 0.6.5

=== debian/changelog ===
secnet (0.6.5) unstable; urgency=medium

  Copyright and source code notices:
  * Include notices and licences of all included elements in LICENCE,
    not just in the files themselvves.
  * Tidy up a handful of notices to the most recent facts.
  * Do not claim CC-BY-SA 4.0 is GPL3+ compatible - only GPL3.
  * Add a README.source.
  * Update my own copyright year.

  * Versions 0.6.3 and 0.6.4 burned due to failed uploads.
    (See dgit bug #944855.)

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 12 Nov 2022 18:58:02 +0000

secnet (0.6.2) unstable; urgency=medium

  Bugfixes to code and build system:
  * site: promote creation of st->scratch, allowing new pubkey scheme
    to work even when secnet is restarting.
  * comm-common.h: Remove unused `notify' variable.  [Colin Watson]
  * Dir.sd.mk: Prevent builtin make rule overwriting conffile.c.

  Documentation:
  * configure: Correct bug reporting address.  Report from Colin Watson.
  * example.conf improvements:
      - Comment out some tuning overrides
      - Improve syntax by deleting one of the two map examples
      - Add a commented-out mobile site setting
      - Add mtu-target
  * OLD-NEWS, OLD-BUGS: Rename from NEWS and BUGS, and don't ship OLD-BUGS.

  Debian packaging changes:
  * debian/rules: Use dh sequencer.  Resulting changes:
      - We now provide debug symbols in the new Debian way.
      - The way the prerm stops secnet accords with modern practice.
  * init script: source /lib/lsb/init-functions.
  * init script: make "restart" work if secnet is not running.
  * Expand Description.
  * debhelper compat: bump to 12 (stretch-backports).
  * debian/rules: Use dh_prep instead of deprecated dh_clean -k.
  * Adjust Priority (as per modern policy and lintian).
  * Add some lintian overrides.
  * Add missing Pre-Depends on init-system-helpers.

  Credits and legal documentation improvements:
  * Add missing credits for base91 and python argparse extension.
    ensure some packaging credits exist in all the places they should be.
  * Add copyright/credits notices to many files which were missing them.
  * Move and centralise legal information into its own file, LICENCE.

  Testing improvements:
  * comprehensive-test: Actually allow OLD_SECNET_DIR set to ''
  * test-example/common.conf: Fix a reference to the sites file.
  * test-example/null-fake-userv: New test utility script.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 30 Dec 2021 15:10:12 +0000

secnet (0.6.1) unstable; urgency=medium

  Logging bugfixes:
  * Fix completely broken startup logging.  Config errors would not
    be repoorted other than via the exit status!  (Broken in 0.6.0.)
  * Suppress various uninteresting messages during startup, to
    avoid noise during successful startup.
  * Move "starting" message earlier.
  
  make-secnet-sites bugfixes:
  * Fix error handling if caller is in wrong group.
  * Fix regressions in handling of delegated sites file fragments
    (especially wrt the optional group parameter to `location').
    Broken since security fixes in 0.5.0.

  Fixes to example config file:
  * Use new name-prefixed format for map(site...) runes.  Old runes
    were desupported by make-secnet-sites security fix (in 0.5.0).
  * Fix "transform" syntax (broken since 0.3.0).

  Other bugfixes and improvements:
  * rsa: Do not crash if private key file is not accessible when
    running --just-check-config.  (Broken since 0.6.0.)
  * rsa: Print errno value if we fail to open key file.
  * config parsing: When closure is of wrong type, give details.
  * Use CLOCK_MONOTONIC for all our timing needs (but only when
    built against an as-yet-unpublished adns feature).

  Supporting changes:
  * Tests for some of the changes.
  * Minor internal refactorings and improvements.
  * Merge subdirmk 1.0.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 24 May 2020 22:14:26 +0100

secnet (0.6.0) unstable; urgency=medium

  Bugfixes:
  * mobile sites: Do not ever expire peer addresses.  In practice
    this fixes transitions between IPv6-only and IPv4-only networks.
  * make-secnet-sites: Tainted: Fix a lot of bad return values
    (which would result in assertions rather than nice error messages).
  * Fix hash algo confusion in mixed sha1/md5 configurations (see below).

  Incompatible changes:
  * site: Always advertise all capabilities, even in MSG1.  This is
    incompatible with secnets earlier than 0.3.0 (September 2013), which
    are all quite badly broken and should have been upgraded long ago.
  * Drop support for using the same loaded rsa key with multiple different
    hash algorithms (which was broken in 0.5.0).  Right now we support
    only `sha1' and `md5' so everyone should be using `sha1'.
    Installations which specified `md5' anywhere may need config changes.

  Major new featureset (use of which is not adviseable yet):
  * New facilities for negotiating about the signing keys to use for
    authentication during key setup, and selecting and using the
    appropriate keys.  (``key-cache'/`privcache' and `peer-keys').
    Using these new facilities for keyrollover now is in principle
    possible but rather complex.  Further machinery is planned;
    for now, retain your existing config which should keep working.
    In summary:
       - secnet: new `privcache' closure;
       - secnet: `key-cache' and `peer-keys' keys on site closures;
       - secnet: new file format for peer public keysets;
       - secnet: new `make-public' config operator;
       - make-secnet-sites `pub', `pkg', `serial', etc. keywords;
       - make-secnet-sites --filter, --pubkeys-*, --output-version.

  More minor (logging) improvements:
  * Make stderr line buffered and log to it by default.
  * Do not log differently with --nodetach.
  * New `prefix' option to `logfile' closure.
  * Tidy and simplify some messages.

  Supporting changes:
  * Many substantial internal refactorings in secnet.


=== debian/control ===
Source: secnet
Section: net
Priority: optional
Maintainer: Ian Jackson <ijackson@chiark.greenend.org.uk>
Uploaders: Stephen Early <steve@greenend.org.uk>,
           Richard Kettlewell <rjk@terraraq.org.uk>
Build-Depends: debhelper (>= 12), libgmp3-dev, libadns1-dev, bison, flex,
               libbsd-dev, python3, tclx, tcl, libtcl-chiark-1
Standards-Version: 4.6.0

Package: secnet
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base
Pre-Depends: ${misc:Pre-Depends}
Recommends: python3
Description: VPN software for distributed networks
 secnet allows multiple private networks, each 'hidden' behind a single
 globally-routable IP address, to be bridged together.  It also
 supports individual client systems which may connect to multiple
 upstreams.
 .
 Compared to many other systems, secnet has good handling of mobile
 endpoints (mobile client nodes), and extremely flexible configuration.
 However, it is not easy to configure.
 .
 secnet works well with userv-ipif (allowing it to run without needing
 root privilege) and hippotat (not currently in Debian).
 .
 secnet is the main VPN program used by greenend.org.uk.

## secnet 0.6.6

=== debian/changelog ===
secnet (0.6.6) unstable; urgency=medium

  Bugfix:
  * polypath: Do not separately log xmit failures.

  Tests:
  * stest: Fix debugging output about spawning secnet

  Packaging:
  * Add missing build-dependency on netbase.  Closes: #1028102.
  * Copyright notices and LICENCE (aka debian/copyright) fixes
    and improvements.  [Requested by Debian ftpmaster]
  * Add Debian upload step to release checklist.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 08 Jan 2023 18:20:09 +0000

## secnet 0.6.7

=== debian/changelog ===
secnet (0.6.7) unstable; urgency=medium

  * Upstream release of changes since 0.6.2.
    (Versions 0.6.5 and 0.6.6 were Debian-only; 0.6.3 and 0.6.4
    were not properly released at all and should be disregarded.)

  Packaging bugfix:
  * Update VERSION in Makefile.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 09 Jan 2023 00:15:21 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Uploaders: Stephen Early <steve@greenend.org.uk>,
            Richard Kettlewell <rjk@terraraq.org.uk>
 Build-Depends: debhelper (>= 12), libgmp3-dev, libadns1-dev, bison, flex,
-               libbsd-dev, python3, tclx, tcl, libtcl-chiark-1
+               libbsd-dev, python3, tclx, tcl, libtcl-chiark-1,
+               netbase
 Standards-Version: 4.6.0
 
 Package: secnet

## secnet 0.6.8

=== debian/changelog ===
secnet (0.6.8) unstable; urgency=medium

  * Avoid using `bool`, `false` and `true` as identifiers.
    Fixes conflicts with modern C and GCC-15.  Closes: #1097866.
  * Remove now-false caveat that hippotat isn't packaged.  It is, now.
    [Report from Tomas Pospisek]  Closes: #1066029.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sat, 20 Sep 2025 11:14:30 +0100

=== debian/control ===
--- 
+++ 
@@ -25,6 +25,6 @@
  However, it is not easy to configure.
  .
  secnet works well with userv-ipif (allowing it to run without needing
- root privilege) and hippotat (not currently in Debian).
+ root privilege) and hippotat.
  .
  secnet is the main VPN program used by greenend.org.uk.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess. 
# Modified for secnet by Stephen Early <steve@greenend.org.uk>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#  This file is Free Software.  It has been incorporated into, and
#  extensively modified, for secnet.
#
#  Copyright 2001      Joey Hess
#  Copyright 2011-2014 Ian Jackson
#
#  You may redistribute this file (and the other source files in the
#  debian/ subdirectory) freely - the copyrightholders declare that
#  they wish these files to be in the public domain.
#
#  You may redistribute secnet as a whole and/or modify it under the
#  terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any
#  later version.
#
#  This software is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this software; if not, see
#  https://www.gnu.org/licenses/gpl.html.

export EXTRA_CFLAGS= $(shell dpkg-buildflags --get CPPFLAGS) \
		     $(shell dpkg-buildflags --get CFLAGS)
export EXTRA_LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@
